// A Java version for the Kaser Interpreter - to call keEvent in
// another thread, passing in idle count and get the result out
// For some of my own fun!
// Stephen M. Bennett
// 29Jun02 Started

package stephen.bennett.kint;


public class CallKEIdleRunnable implements Runnable {
  private int idleCount;
  private int result;

  // constructor
  public CallKEIdleRunnable(int ic) {
    idleCount = ic;
  }

  public int getResult() {
    return result;
  }
        
  public void run() { 
    Log.info("Calling KEEVENT_IDLE, idleCount", idleCount);
    result = KInt.keEvent(KInt.KEEVENT_IDLE, idleCount, 0, 0);
  }


  // Return our CVS id
  public static String getCVSID() {
    return "$Id: CallKEIdleRunnable.java,v 1.2 2002/10/06 15:29:08 Bennett Stephen Exp $";
  }

}



/*
 * $Log: CallKEIdleRunnable.java,v $
 * Revision 1.2  2002/10/06 15:29:08  Bennett Stephen
 * CVS method added
 *
 * Revision 1.1  2002/08/07 19:22:22  Bennett Stephen
 * Initial Version
 *
 *
 */

// ----------------------------------------------------
// Emacs magic - please do not remove the following lines
/*
 * Local Variables:
 * write-contents-hooks: ((lambda () (untabify (point-min) (point-max))))
 * End:
*/
// ----------------------------------------------------
