// A Java version for the Kaser Interpreter - The Timer Listener
// For some of my own fun!
// Stephen M. Bennett
// 29Jun02 Started

package stephen.bennett.kint;

import java.awt.event.*;


// Map interesting timer (action) events to calls on KE Event

class KTimerListener implements ActionListener {
  // the timer has fired, calls KE Event
  public void actionPerformed(ActionEvent e) {
    Log.fine("Timer fired");

    // call the .KE event, only if program ready
    if (KInt.isProgramReady()) {
      Log.info("Calling KEEVENT_TIMER");
      KInt.keEvent(KInt.KEEVENT_TIMER, 0, 0, 0);

      // this was an interesting event
      UI.setMostRecentEventTime();
    }
    else {
      Log.info("Progam not yet ready, timer event ignored");
    }
  }


  // Return our CVS id
  public static String getCVSID() {
    return "$Id: KTimerListener.java,v 1.2 2002/10/06 15:27:13 Bennett Stephen Exp $";
  }


}


/*
 * $Log: KTimerListener.java,v $
 * Revision 1.2  2002/10/06 15:27:13  Bennett Stephen
 * CVS method added
 *
 * Revision 1.1  2002/08/07 19:22:20  Bennett Stephen
 * Initial Version
 *
 *
 */

// ----------------------------------------------------
// Emacs magic - please do not remove the following lines
/*
 * Local Variables:
 * write-contents-hooks: ((lambda () (untabify (point-min) (point-max))))
 * End:
*/
// ----------------------------------------------------
