// A Java version for the Kaser Interpreter - the Memory methods
// For some of my own fun!
// Stephen M. Bennett
// 29Jun02 Started

package stephen.bennett.kint;


// the imports
import java.util.*;


// here we go
public class Mem {
  // the reg offsets into the byte arrays for each numbered register
  public final static int REG_0   = 0x00;
  public final static int REG_1   = 0x04;
  public final static int REG_2   = 0x08;
  public final static int REG_3   = 0x0C;
  public final static int REG_4   = 0x10;
  public final static int REG_5   = 0x14;
  public final static int REG_6   = 0x18;
  public final static int REG_7   = 0x1C;
  public final static int REG_8   = 0x20;
  public final static int REG_9   = 0x24;
  public final static int REG_10  = 0x28;
  public final static int REG_11  = 0x2C;
  public final static int REG_12  = 0x30;
  public final static int REG_13  = 0x34;
  public final static int REG_14  = 0x38;
  public final static int REG_15  = 0x3C;
  public final static int REG_16  = 0x40;
  public final static int REG_17  = 0x44;
  public final static int REG_18  = 0x48;
  public final static int REG_19  = 0x4C;
  public final static int REG_20  = 0x50;
  public final static int REG_21  = 0x54;
  public final static int REG_22  = 0x58;
  public final static int REG_23  = 0x5C;
  public final static int REG_24  = 0x60;
  public final static int REG_25  = 0x64;
  public final static int REG_26  = 0x68;
  public final static int REG_27  = 0x6C;
  public final static int REG_28  = 0x70;
  public final static int REG_29  = 0x74;
  public final static int REG_30  = 0x78;
  public final static int REG_31  = 0x7C;
  public final static int REG_32  = 0x80;
  public final static int REG_33  = 0x82;
  public final static int REG_34  = 0x84;
  public final static int REG_35  = 0x86;
  public final static int REG_36  = 0x88;
  public final static int REG_37  = 0x8A;
  public final static int REG_38  = 0x8C;
  public final static int REG_39  = 0x8E;
  public final static int REG_40  = 0x90;
  public final static int REG_41  = 0x92;
  public final static int REG_42  = 0x94;
  public final static int REG_43  = 0x96;
  public final static int REG_44  = 0x98;
  public final static int REG_45  = 0x9A;
  public final static int REG_46  = 0x9C;
  public final static int REG_47  = 0x9E;
  public final static int REG_48  = 0xA0;
  public final static int REG_49  = 0xA2;
  public final static int REG_50  = 0xA4;
  public final static int REG_51  = 0xA6;
  public final static int REG_52  = 0xA8;
  public final static int REG_53  = 0xAA;
  public final static int REG_54  = 0xAC;
  public final static int REG_55  = 0xAE;
  public final static int REG_56  = 0xB0;
  public final static int REG_57  = 0xB2;
  public final static int REG_58  = 0xB4;
  public final static int REG_59  = 0xB6;
  public final static int REG_60  = 0xB8;
  public final static int REG_61  = 0xBA;
  public final static int REG_62  = 0xBC;
  public final static int REG_63  = 0xBE;
  public final static int REG_64  = 0xC0;
  public final static int REG_65  = 0xC2;
  public final static int REG_66  = 0xC4;
  public final static int REG_67  = 0xC6;
  public final static int REG_68  = 0xC8;
  public final static int REG_69  = 0xCA;
  public final static int REG_70  = 0xCC;
  public final static int REG_71  = 0xCE;
  public final static int REG_72  = 0xD0;
  public final static int REG_73  = 0xD2;
  public final static int REG_74  = 0xD4;
  public final static int REG_75  = 0xD6;
  public final static int REG_76  = 0xD8;
  public final static int REG_77  = 0xDA;
  public final static int REG_78  = 0xDC;
  public final static int REG_79  = 0xDE;
  public final static int REG_80  = 0xE0;
  public final static int REG_81  = 0xE1;
  public final static int REG_82  = 0xE2;
  public final static int REG_83  = 0xE3;
  public final static int REG_84  = 0xE4;
  public final static int REG_85  = 0xE5;
  public final static int REG_86  = 0xE6;
  public final static int REG_87  = 0xE7;
  public final static int REG_88  = 0xE8;
  public final static int REG_89  = 0xE9;
  public final static int REG_90  = 0xEA;
  public final static int REG_91  = 0xEB;
  public final static int REG_92  = 0xEC;
  public final static int REG_93  = 0xED;
  public final static int REG_94  = 0xEE;
  public final static int REG_95  = 0xEF;
  public final static int REG_96  = 0xF0;
  public final static int REG_97  = 0xF1;
  public final static int REG_98  = 0xF2;
  public final static int REG_99  = 0xF3;
  public final static int REG_100 = 0xF4;
  public final static int REG_101 = 0xF5;
  public final static int REG_102 = 0xF6;
  public final static int REG_103 = 0xF7;
  public final static int REG_104 = 0xF8;
  public final static int REG_105 = 0xF9;
  public final static int REG_106 = 0xFA;
  public final static int REG_107 = 0xFB;
  public final static int REG_108 = 0xFC;
  public final static int REG_109 = 0xFD;
  public final static int REG_110 = 0xFE;
  public final static int REG_111 = 0xFF;


  // the allocated memory
  private static Vector allocatedMem = new Vector();


  //*****************************************
  // Register Methods
  //*****************************************

  // set the given register bytes, from the reg offset, to the given DWORD value
  public static int SETREGD(byte[] regs, int reg, int value) {
    return SETMEMD(regs, reg, value);
  }

  // set the given register bytes, from the reg offset, to the given WORD value
  public static short SETREGW(byte[] regs, int reg, short value) {
    return SETMEMW(regs, reg, value);
  }

  // set the given register bytes, from the reg offset, to the given BYTE value
  public static byte SETREGB(byte[] regs, int reg, byte value) {
    return SETMEMB(regs, reg, value);
  }

  // get the reg offset from the given register bytes as a DWORD
  // assumes array is long enough
  public static int GETREGD(byte[] regs, int reg) {
    return GETMEMD(regs, reg);
  }

  // get the reg offset from the given register bytes as a WORD
  // assumes array is long enough
  public static short GETREGW(byte[] regs, int reg) {
    return GETMEMW(regs, reg);
  }

  // get the reg offset from the given register bytes as a BYTE
  // assumes array is long enough
  public static byte GETREGB(byte[] regs, int reg) {
    return GETMEMB(regs, reg);
  }


  //*****************************************
  // Memory 'Register' Methods
  //*****************************************

  // set the given bytes, from the offset, to the given DWORD value
  public static int SETMEMD(byte[] bytes, int offset, int value) {
    bytes[offset++] = (byte)( value       & 0xff);
    bytes[offset++] = (byte)((value>>>8)  & 0xff);
    bytes[offset++] = (byte)((value>>>16) & 0xff);
    bytes[offset]   = (byte)((value>>>24) & 0xff);
    return value;
  }

  // set the given register bytes, from the reg offset, to the given DWORD value
  public static short SETMEMW(byte[] bytes, int offset, short value) {
    bytes[offset++] = (byte)( value      & 0xff);
    bytes[offset]   = (byte)((value>>>8) & 0xff);
    return value;
  }

  // set the given register bytes, from the reg offset, to the given BYTE value
  public static byte SETMEMB(byte[] bytes, int offset, byte value) {
    bytes[offset] = (byte)(value & 0xff);
    return value;
  }

  // convert the DWORD from the given bytes to an int from the offset
  // assumes array is long enough
  public static int GETMEMD(byte[] bytes, int offset) {
    int b1 = bytes[offset++] & 0xff;
    int b2 = bytes[offset++] & 0xff;
    int b3 = bytes[offset++] & 0xff;
    int b4 = bytes[offset]   & 0xff;
    return (b4<<24)|(b3<<16)|(b2<<8)|b1;
  }

  // convert the WORD from the given bytes to an int from the offset
  // assumes array is long enough
  public static short GETMEMW(byte[] bytes, int offset) {
    int b1 = bytes[offset++] & 0xff;
    int b2 = bytes[offset]   & 0xff;

    return (short)((b2<<8)|b1);
  }

  // convert the BYTE from the given bytes to an int from the offset
  // assumes array is long enough
  public static byte GETMEMB(byte[] bytes, int offset) {
    //Log.severe("GETMEMB offset", offset);
    byte b1 = bytes[offset];

    return b1;
  }


  //*****************************************
  // String Methods
  //*****************************************

  // return a Java string for null terminated string at given offset
  public static String getString(byte[] bytes, int offset) {
    // determine the length up to the null byte
    int len = 0;
    int i=offset;
    while(bytes[i++] != 0) {
      len++;
    }
    return new String(bytes, offset, len);
  }

  
  // set a Java string to give bytes at given offset, returning new offset
  // boolean says if C null char is added
  public static int setString(byte[] bytes, int offset, String s, 
                              boolean addNull) {
    // put each char in
    int len = s.length();
    for(int i=0; i<len; i++) {
      bytes[offset++] = (byte)s.charAt(i);
    }
    if (addNull) {
      bytes[offset++] = 0;
    }
    return offset;
  }


  //******************************************
  // C Memory functions
  //******************************************

  // memset - set n bytes to value v
  public static void memset(byte[] theMem, int offset, byte v, int n) {
    while(n-- > 0) {
      theMem[offset++] = v;
    }
  }

  // memcpy - copy n bytes of src to dst
  public static void memcpy(byte[] dst, int dstoffset, 
                            byte[] src, int srcoffset, int n) {
    System.arraycopy(src, srcoffset, dst, dstoffset, n);
  }

  // memmove - move n bytes of src to dst
  // java copes with overlapping memory
  public static void memmove(byte[] dst, int dstoffset, 
                             byte[] src, int srcoffset, int n) {
    System.arraycopy(src, srcoffset, dst, dstoffset, n);
  }

  // memcmp - compare n bytes of the given memory
  public static int memcmp(byte[] theMem, int offset,
                           byte[] theMem2, int offset2, int n) {
    int result = 0;
    while(n-- > 0) {
      if ((result = theMem[offset++] - theMem2[offset2++]) != 0)
        break;
    }
    Log.fine("memcmp result", result);
    return result;
  }


  //******************************************
  // C String functions - treating bytes as ascii chars!
  //******************************************

  // strcpy - copy src to dst (including null char)
  public static void strcpy(byte[] dst, int dstoffset,
                            byte[] src, int srcoffset) {
    while(src[srcoffset] != 0) {
      dst[dstoffset++] = src[srcoffset++];
    }
    dst[dstoffset] = 0;
  }

  // strlen - return the length of the string (not including null char)
  public static int strlen(byte[] theMem, int offset) {
    int result = 0;
    while(theMem[offset++] != 0) {
      result++;
    }
    Log.fine("strlen result", result);
    return result;
  }

  // strcmp - compare two strings
  public static int strcmp(byte[] theMem, int offset, 
                           byte[] theMem2, int offset2) {
    int result;
    while(true) {
      if ((result = theMem[offset] - theMem2[offset2++]) != 0 ||
          theMem[offset++] == 0) {
        break;
      }
    }
    Log.fine("strcmp result", result);
    return result;
  }

  // stricmp - compare two strings case insensitive
  public static int stricmp(byte[] theMem, int offset, 
                            byte[] theMem2, int offset2) {
    int result;
    while(true) {
      if ((result = toupper(theMem[offset]) - toupper(theMem2[offset2++])) != 0 ||
          theMem[offset++] == 0) {
        break;
      }
    }
    Log.fine("stricmp result", result);
    return result;
  }

  // support method - bit of a hack - hard coding ASCII instead of using Java 
  // chars - as much as is needed really, could improve
  private static byte toupper(byte b) {
    if (b >= 0x61 && b <= 0x7a) {
      return (byte)(b-0x20);
    }
    return b;
  }


  //*****************************************
  // Type Conversions Methods
  //*****************************************

  // convert byte to unsigned byte (hence must be held in, at least, short)
  public static short bUnsigned(byte b) {
    return (short)(b & 0xff);
  }

  // convert word to unsigned word (hence must be held in int)
  public static int wUnsigned(short s) {
    return (s & 0xffff);
  }

  // convert dword to unsigned dword (hence must be held in long)
  public static long dUnsigned(int i) {
    return (i & 0xffffffffL);
  }


  //*****************************************
  // Memory Allocation/Free Methods
  //*****************************************

  // allocate the required Mem, give size, return the handle
  // memory handle = index into Vector+1
  public static int allocateMem(int size) {
    Log.fine("Allocating memory", size);

    // don't think will want to allocate 0 memory, so exit if this happens
    // will remove if a valid 0 call is proved
    if (size == 0) {
      Log.errorExit("0 size given to allocateMem");
    }

    // Add an extra bit, as processing of ORDER.TXT reads too much
    //size = size+4;

    // get some memory (byte array for us)
    byte[] theMem = new byte[size];

    // remember it, returning the handle
    int memoryHandle = Utils.addObjectToHandles(theMem, allocatedMem, 
                                                true, "allocatedMem");
    return memoryHandle;
  }


  // free Memory given the memory handle
  // for us, just remove the entry in Vector and let garbage collector do its job
  public static void freeMem(int memoryHandle) {
    Log.fine("Freeing memory handle", memoryHandle);

    // just set it to null, and let the garbage collector do its work!
    Utils.removeObjectByHandle(memoryHandle, allocatedMem, true, "allocatedMem");
  }


  // get the memory whose handle is in given register
  public static byte[] getMemByRegHandle(byte[] regs, int reg) {
    // get the memory handle from that register
    int memoryHandle = Mem.GETREGD(regs, reg);
    return getMemByHandle(memoryHandle);
  }


  // get the memory whose memory handle has been given
  public static byte[] getMemByHandle(int memoryHandle) {
    // return that memory
    return (byte[])Utils.getObjectByHandle(memoryHandle, allocatedMem, true,
                                           "allocatedMem");
  }


  // get the memory based on give byte register
  // 0 for kode, 1 means memory handle in R1, 2 means memory handle in R2
  // actually now 0 can go through memory handle in R0, but as we are given
  // code it is more effecient just to use kode
  public static byte[] getMemByRegIndicator(byte[] regs, int breg, byte[] kode) {
    // get the value in register
    byte bVal = Mem.GETREGB(regs, breg);
    Log.fine("bVal", bVal);

    // 0 means kode
    if (bVal == 0) {
      return kode;
    }

    // memory handle is in r1 or r2
    int reg = 0;
    if (bVal == 1) {
      reg = Mem.REG_1;
    }
    else if (bVal == 2) {
      reg = Mem.REG_2;
    }
    else {
      Log.errorExit("Bad byte register memory indicator value", bVal);
    }

    return getMemByRegHandle(regs, reg);
  }


  // Return our CVS id
  public static String getCVSID() {
    return "$Id: Mem.java,v 1.5 2002/11/28 19:32:29 Bennett Stephen Exp $";
  }


}


/*
 * $Log: Mem.java,v $
 * Revision 1.5  2002/11/28 19:32:29  Bennett Stephen
 * release candidate 1 version
 *
 * Revision 1.4  2002/10/06 15:25:59  Bennett Stephen
 * added setString
 *
 * Revision 1.3  2002/09/08 19:41:19  Bennett Stephen
 * use generic code for handles
 *
 * Revision 1.2  2002/08/10 08:20:30  Bennett Stephen
 * added C mem/str funcs
 *
 * Revision 1.1  2002/08/07 19:22:20  Bennett Stephen
 * Initial Version
 *
 *
 */

// ----------------------------------------------------
// Emacs magic - please do not remove the following lines
/*
 * Local Variables:
 * write-contents-hooks: ((lambda () (untabify (point-min) (point-max))))
 * End:
*/
// ----------------------------------------------------
