// A Java version for the Kaser Interpreter - the Text State
// For some of my own fun!
// Stephen M. Bennett
// 29Jun02 Started

package stephen.bennett.kint;

import java.awt.*;

public class TextState {
  // text state back modes
  public final static int BACKMODE_OPAQUE      = 1;
  public final static int BACKMODE_TRANSPARENT = 2;
  

  // our text state information
  private Color textColour;
  private Color backColour;
  private int backMode;
  private Font font;

  // the constructor
  public TextState(Color tc, Color bc, int bm, Font f) {
    textColour = tc;
    backColour = bc;
    backMode = bm;
    font = f;
  }

  
  // the getters
  public Color getTextColour() {
    return textColour;
  }

  public Color getBackColour() {
    return backColour;
  }

  public int getBackMode() {
    return backMode;
  }

  public Font getFont() {
    return font;
  }


  // Return our CVS id
  public static String getCVSID() {
    return "$Id: TextState.java,v 1.2 2002/10/06 15:24:38 Bennett Stephen Exp $";
  }


}


/*
 * $Log: TextState.java,v $
 * Revision 1.2  2002/10/06 15:24:38  Bennett Stephen
 * added background colour and mode
 *
 * Revision 1.1  2002/08/07 19:22:19  Bennett Stephen
 * Initial Version
 *
 *
 */

// ----------------------------------------------------
// Emacs magic - please do not remove the following lines
/*
 * Local Variables:
 * write-contents-hooks: ((lambda () (untabify (point-min) (point-max))))
 * End:
*/
// ----------------------------------------------------
